https://build.opensuse.org/package/view_file?file=abiword-2.8.6-libpng15.patch&package=mingw64-abiword&project=windows%3Amingw%3Awin64
--- src/af/util/xp/ut_png.cpp	2008-02-24 04:33:07.000000000 +0100
+++ src/af/util/xp/ut_png.cpp	2011-02-24 11:53:18.954524499 +0100
@@ -71,7 +71,7 @@
 	 * the normal method of doing things with libpng).  REQUIRED unless you
 	 * set up your own error handlers in the png_create_read_struct() earlier.
 	 */
-	if (setjmp(png_ptr->jmpbuf))
+	if (setjmp(png_jmpbuf(png_ptr)))
 	{
 		/* Free all of the memory associated with the png_ptr and info_ptr */
 		png_destroy_read_struct(&png_ptr, &info_ptr, static_cast<png_infopp>(NULL));
--- src/wp/impexp/gtk/ie_impGraphic_GdkPixbuf.cpp	2009-07-01 06:02:04.000000000 +0200
+++ src/wp/impexp/gtk/ie_impGraphic_GdkPixbuf.cpp	2011-02-24 11:53:19.039523946 +0100
@@ -185,7 +185,7 @@
 /** needed for the stejmp context */
 UT_Error IE_ImpGraphic_GdkPixbuf::_png_write(GdkPixbuf * pixbuf)
 {
-	if (setjmp(m_pPNG->jmpbuf))
+	if (setjmp(png_jmpbuf(m_pPNG)))
 	{
 		DELETEP(m_pPngBB);
 		png_destroy_write_struct(&m_pPNG, &m_pPNGInfo);
@@ -446,7 +446,7 @@
 	 * the normal method of doing things with libpng).  REQUIRED unless you
 	 * set up your own error handlers in the png_create_read_struct() earlier.
 	 */
-	if (setjmp(m_pPNG->jmpbuf))
+	if (setjmp(png_jmpbuf(m_pPNG)))
 	{
 		/* Free all of the memory associated with the png_ptr and info_ptr */
 		png_destroy_write_struct(&m_pPNG, &m_pPNGInfo);
--- plugins/bmp/xp/ie_impGraphic_BMP.cpp	2009-06-25 04:02:06.000000000 +0000
+++ plugins/bmp/xp/ie_impGraphic_BMP.cpp	2011-03-01 20:09:04.810810063 +0000
@@ -191,7 +191,7 @@
 
 	/* Clean Up Memory Used */
 		
-	FREEP(m_pPNGInfo->palette);
+//	FREEP(m_pPNGInfo->palette);
 	DELETEP(pBB);
 	png_destroy_write_struct(&m_pPNG, &m_pPNGInfo);
    
@@ -313,7 +313,7 @@
 	 * the normal method of doing things with libpng).  REQUIRED unless you
 	 * set up your own error handlers in the png_create_read_struct() earlier.
 	 */
-	if (setjmp(m_pPNG->jmpbuf))
+	if (setjmp(png_jmpbuf(m_pPNG)))
 	{
 		/* Free all of the memory associated with the png_ptr and info_ptr */
 		png_destroy_write_struct(&m_pPNG, &m_pPNGInfo);
@@ -332,7 +332,7 @@
 	UT_Error IE_ImpGraphic_BMP::Convert_BMP_Pallet(UT_ByteBuf* pBB)
 	{
 		/* Reset error handling for libpng */
-		if (setjmp(m_pPNG->jmpbuf))
+		if (setjmp(png_jmpbuf(m_pPNG)))
 		{
 			png_destroy_write_struct(&m_pPNG, &m_pPNGInfo);
 			return UT_ERROR;
@@ -372,7 +372,7 @@
 UT_Error IE_ImpGraphic_BMP::Convert_BMP(UT_ByteBuf* pBB)
 {
 	/* Reset error handling for libpng */
-	if (setjmp(m_pPNG->jmpbuf))
+	if (setjmp(png_jmpbuf(m_pPNG)))
 	{
 		png_destroy_write_struct(&m_pPNG, &m_pPNGInfo);
 		return UT_ERROR;
--- plugins/garble/xp/abiword-garble-png.cpp	2009-09-05 15:34:44.000000000 +0000
+++ plugins/garble/xp/abiword-garble-png.cpp	2011-03-01 19:39:57.591809416 +0000
@@ -79,7 +79,7 @@
 		png_set_strip_alpha( png_ptr );
 		png_set_interlace_handling( png_ptr );
 		png_set_bgr( png_ptr );
-		rowbytes = info_ptr->rowbytes;
+		rowbytes = png_get_rowbytes(png_ptr, info_ptr);
 		png_destroy_read_struct( &png_ptr, &info_ptr, NULL );
 	}
 
--- src/af/gr/win/gr_Win32Image.cpp	2009-07-08 17:33:53.000000000 +0000
+++ src/af/gr/win/gr_Win32Image.cpp	2011-03-01 18:01:21.651747071 +0000
@@ -148,7 +148,7 @@
 	info_ptr = png_create_info_struct(png_ptr);
 
 	// libpng will longjmp back to here if a fatal error occurs
-	if (setjmp(png_ptr->jmpbuf))
+	if (setjmp(png_jmpbuf(png_ptr)))
 	{
 		/* If we get here, we had a problem reading the file */
 		png_destroy_write_struct(&png_ptr,  (png_infopp)NULL);
@@ -547,7 +547,7 @@
 	 * the normal method of doing things with libpng).  REQUIRED unless you
 	 * set up your own error handlers in the png_create_read_struct() earlier.
 	 */
-	if (setjmp(png_ptr->jmpbuf))
+	if (setjmp(png_jmpbuf(png_ptr)))
 	{
 		/* Free all of the memory associated with the png_ptr and info_ptr */
 		png_destroy_read_struct(&png_ptr, &info_ptr, (png_infopp)NULL);
--- src/wp/impexp/win/ie_impGraphic_Win32Native.cpp	2009-07-07 16:50:18.000000000 +0000
+++ src/wp/impexp/win/ie_impGraphic_Win32Native.cpp	2011-03-01 19:04:51.469746321 +0000
@@ -405,7 +405,7 @@
     
     /* Clean Up Memory Used */
 		
-    FREEP(m_pPNGInfo->palette);	
+//    FREEP(m_pPNGInfo->palette);	
     png_destroy_write_struct(&m_pPNG, &m_pPNGInfo);
     
     return UT_OK;  	  	
@@ -501,7 +501,7 @@
      * the normal method of doing things with libpng).  REQUIRED unless you
      * set up your own error handlers in the png_create_read_struct() earlier.
      */
-    if (setjmp(m_pPNG->jmpbuf))
+    if (setjmp(png_jmpbuf(m_pPNG)))
 	{
 		/* Free all of the memory associated with the png_ptr and info_ptr */
 		png_destroy_write_struct(&m_pPNG, &m_pPNGInfo);
@@ -520,7 +520,7 @@
 UT_Error IE_ImpGraphic_Win32Native::Convert_BMP_Palette(UT_ByteBuf* pBB)
 {
     /* Reset error handling for libpng */
-    if (setjmp(m_pPNG->jmpbuf))
+    if (setjmp(png_jmpbuf(m_pPNG)))
 	{
 		png_destroy_write_struct(&m_pPNG, &m_pPNGInfo);
 		return UT_ERROR;
@@ -560,7 +560,7 @@
 UT_Error IE_ImpGraphic_Win32Native::Convert_BMP(UT_ByteBuf* pBB)
 {
     /* Reset error handling for libpng */
-    if (setjmp(m_pPNG->jmpbuf))
+    if (setjmp(png_jmpbuf(m_pPNG)))
 	{
 		png_destroy_write_struct(&m_pPNG, &m_pPNGInfo);
 		return UT_ERROR;
